> For the complete documentation index, see [llms.txt](https://docs.checkpoint.snapshot.box/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.checkpoint.snapshot.box/core-concepts/checkpoint-configuration.md).

# Checkpoint configuration

Checkpoint uses a configuration object to determine which networks and contract information it will be indexing.

```typescript
// Configuration used to initialize Checkpoint
export interface CheckpointConfig {
  network_node_url: string;
  optimistic_indexing?: boolean;
  fetch_interval?: number; 
  tx_fn?: string;
  global_events?: ContractSourceConfig[];
  sources?: ContractSourceConfig[];
  templates?: { [key: string]: ContractTemplate };
  // mapping from ABI name to contract ABI
  abis?: { [key: string]: any };
}

export interface ContractEventConfig {
  // name of event in the contract
  name: string;
  // callback function in writer
  fn: string;
}

export interface ContractSourceConfig {
  // contract address
  contract: string;
  // name of ABI (if used it Checkpoint will parse events using provided ABI)
  abi?: string;
  // start block number
  start: number;
  // callback function in writer to handle deployment
  deploy_fn?: string;
  events: ContractEventConfig[];
}

export interface ContractTemplate {
  // name of ABI (if used it Checkpoint will parse events using provided ABI)
  abi?: string;
  events: ContractEventConfig[];
};
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.checkpoint.snapshot.box/core-concepts/checkpoint-configuration.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
